#!/bin/sh
# 
# Pure-FTPD include/exclude/edit users script
#
# Copyright (C) 2013 Projeto Addons <www.addons.com.br>
# Copyright (C) 2013 Marcio José <marcioteck@gmail.com.br>
#
# For complete documentation, please visit Projeto Addons:
# http://www.addons.com.br/
#
# This file is part of the Addon Pure-FTPd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

. /etc/brazilfw/pure-ftpd/pure-ftpd.cfg

. ../../functions/functions

FILECONFIG="/etc/brazilfw/pure-ftpd/pure-ftpd.passwd"

case "$FORM_action" in
     delete)
     deleteline $FORM_id $FILECONFIG
     /usr/local/bin/pure-pw mkdb /etc/brazilfw/pure-ftpd/pure-ftpd.pdb -f /etc/brazilfw/pure-ftpd/pure-ftpd.passwd
     ;;
     edit)
     if [ "$FORM_password" = "$FORM_old_password" ]; then
        FORM_login=$(echo $FORM_login | sed 's/ //g')
        [ ! -z "$FORM_upload" -a "$FORM_upload" != "0" ] && FORM_upload=$(($FORM_upload * 1024))
        [ ! -z "$FORM_download" -a "$FORM_download" != "0" ] && FORM_download=$(($FORM_download * 1024))
        [ ! -z "$FORM_size" -a "$FORM_size" != "0" ] && FORM_size=$(($FORM_size * 1024))
        [ ! -z "$FORM_size" -a "$FORM_size" != "0" ] && FORM_size=$(($FORM_size * 1024))
        [ ! -z "$FORM_hour_start" ] && TIME="$FORM_hour_start" || TIME=""
        [ ! -z "$TIME" ] && TIME=$TIME"-" || TIME=""
        [ ! -z "$TIME" -a ! -z "$FORM_hour_stop" ] && TIME="$TIME$FORM_hour_stop" || TIME=""
        TIME=$(echo $TIME | sed 's/://g')
        FORM_directory=$PUREFTPD_PATH$FORM_directory
        [ "$FORM_total_access" = "-d" ] && FORM_directory="$FORM_directory/./"
        changeline $FORM_id "$FORM_login:$FORM_password:65534:65534::$FORM_directory:$FORM_upload:$FORM_download:$FORM_upload:$FORM_download::$FORM_files:$FORM_size:::::$TIME" $FILECONFIG
        /usr/local/bin/pure-pw mkdb /etc/brazilfw/pure-ftpd/pure-ftpd.pdb -f /etc/brazilfw/pure-ftpd/pure-ftpd.passwd
     else
        deleteline $FORM_id $FILECONFIG
        FORM_login=$(echo $FORM_login | sed 's/ //g')
        echo $FORM_password >/tmp/passwd.tmp
        echo $FORM_password >>/tmp/passwd.tmp
        [ ! -z "$FORM_upload" -a "$FORM_upload" != "0" ] && FORM_upload=$(($FORM_upload * 1024))
        [ ! -z "$FORM_upload" -a "$FORM_upload" != "0" ] && FORM_upload="-q $FORM_upload -T $FORM_upload" || FORM_upload=""
        [ ! -z "$FORM_download" -a "$FORM_download" != "0" ] && FORM_download=$(($FORM_download * 1024))
        [ ! -z "$FORM_download" -a "$FORM_download" != "0" ] && FORM_download="-Q $FORM_download -t $FORM_download" || FORM_download=""
        [ ! -z "$FORM_files" -a "$FORM_files" != "0" ] && FORM_files="-n $FORM_files" || FORM_files=""
        [ ! -z "$FORM_size" -a "$FORM_size" != "0" ] && FORM_size=$(($FORM_size * 1024))
        [ ! -z "$FORM_size" -a "$FORM_size" != "0" ] && FORM_size=$(($FORM_size * 1024))
        [ ! -z "$FORM_size" -a "$FORM_size" != "0" ] && FORM_size="-N $FORM_size" || FORM_size=""
        [ ! -z "$FORM_hour_start" ] && TIME="-z $FORM_hour_start" || TIME=""
        [ ! -z "$TIME" ] && TIME=$TIME"-" || TIME=""
        [ ! -z "$TIME" -a ! -z "$FORM_hour_stop" ] && TIME="$TIME$FORM_hour_stop" || TIME=""
        TIME=$(echo $TIME | sed 's/://g')
        /usr/local/bin/pure-pw useradd $FORM_login -f /etc/brazilfw/pure-ftpd/pure-ftpd.passwd -u nobody $FORM_total_access $PUREFTPD_PATH$FORM_directory $FORM_files $FORM_size $FORM_upload $FORM_download $TIME < /tmp/passwd.tmp >/dev/null 2>&1
        /usr/local/bin/pure-pw mkdb /etc/brazilfw/pure-ftpd/pure-ftpd.pdb -f /etc/brazilfw/pure-ftpd/pure-ftpd.passwd
        rm -Rf /tmp/passwd.tmp
     fi
     ;;
     add)
     FORM_login=$(echo $FORM_login | sed 's/ //g')
     echo $FORM_password >/tmp/passwd.tmp
     echo $FORM_password >>/tmp/passwd.tmp
     [ ! -z "$FORM_upload" -a "$FORM_upload" != "0" ] && FORM_upload=$(($FORM_upload * 1024))
     [ ! -z "$FORM_upload" -a "$FORM_upload" != "0" ] && FORM_upload="-q $FORM_upload -T $FORM_upload" || FORM_upload=""
     [ ! -z "$FORM_download" -a "$FORM_download" != "0" ] && FORM_download=$(($FORM_download * 1024))
     [ ! -z "$FORM_download" -a "$FORM_download" != "0" ] && FORM_download="-Q $FORM_download -t $FORM_download" || FORM_download=""
     [ ! -z "$FORM_files" -a "$FORM_files" != "0" ] && FORM_files="-n $FORM_files" || FORM_files=""
     [ ! -z "$FORM_size" -a "$FORM_size" != "0" ] && FORM_size=$(($FORM_size * 1024))
     [ ! -z "$FORM_size" -a "$FORM_size" != "0" ] && FORM_size=$(($FORM_size * 1024))
     [ ! -z "$FORM_size" -a "$FORM_size" != "0" ] && FORM_size="-N $FORM_size" || FORM_size=""
     [ ! -z "$FORM_hour_start" ] && TIME="-z $FORM_hour_start" || TIME=""
     [ ! -z "$TIME" ] && TIME=$TIME"-" || TIME=""
     [ ! -z "$TIME" -a ! -z "$FORM_hour_stop" ] && TIME="$TIME$FORM_hour_stop" || TIME=""
     TIME=$(echo $TIME | sed 's/://g')
     /usr/local/bin/pure-pw useradd $FORM_login -f /etc/brazilfw/pure-ftpd/pure-ftpd.passwd -u nobody $FORM_total_access $PUREFTPD_PATH$FORM_directory $FORM_files $FORM_size $FORM_upload $FORM_download $TIME < /tmp/passwd.tmp >/dev/null 2>&1
     /usr/local/bin/pure-pw mkdb /etc/brazilfw/pure-ftpd/pure-ftpd.pdb -f /etc/brazilfw/pure-ftpd/pure-ftpd.passwd
     rm -Rf /tmp/passwd.tmp
     ;;
esac

init_html
language /pure-ftpd/pure-ftpd

init_script
    init_function "form_reload"
         script_execute ". /etc/init.d/pureftpd restart" "$PUREFTPD014"
    end_function

    init_function "form_delete" "ID,user"
        window_confirm "$PUREFTPD015" "$(script_post "/pure-ftpd/pure-ftpd-user.cgi" "{action:'delete',id:ID}")"
    end_function

    init_function "form_add"
        script_formshow "pureftpd-users" "add"
        set_form_value "pureftpd-users" "action" "'add'"
        set_form_value "pureftpd-users" "total_access" "'-d'"
    end_function

    init_function "chrooted_return" "directory"
        echo -e "var CHROOTED_CHECK=directory.substr(directory.length-3);\nif (CHROOTED_CHECK == \"/./\")\n{\nvar CHROOTED=\"-d\";\n}\nelse\n{\nCHROOTED=\"-D\";\n}\nreturn CHROOTED;"
    end_function

    init_function "directory_return" "directory"
        echo -e "var DIRECTORY_USER=directory.replace(\"$PUREFTPD_PATH\",\"\");\nvar DIRECTORY_RESULT=DIRECTORY_USER.replace(\"/./\",\"\");\nreturn DIRECTORY_RESULT;"
    end_function

    init_function "bandwidth_return" "bandwidth"
        echo -e "var QUOTA=\"\"\nif (bandwidth != \"\" && bandwidth != \"0\" && !(bandwidth.match(/^\s+$/)))\n{\nQUOTA=bandwidth/1024;\n}\nreturn QUOTA;"
    end_function

    init_function "size_return" "size"
        echo -e "var QUOTA=\"\"\nif (size != \"\" && size != \"0\" && !(size.match(/^\s+$/)))\n{\nvar SIZE=size/1024;\nvar QUOTA=SIZE/1024;\n}\nreturn QUOTA;"
    end_function

    init_function "format_hour_start" "hour"
        echo -e "var HOUR=hour.substr(0,hour.indexOf(\"-\"));\nvar Length=HOUR.length;\nif (Length == 3)\n{\nvar TIME=hour.substr(0,1)+\":\"+hour.substr(1,2);\nreturn TIME;\n}\nelse if (Length == 4)\n{\nvar TIME=hour.substr(0,2)+\":\"+hour.substr(2,2);\nreturn TIME;\n}\nelse\n{\nvar TIME=\"\"\nreturn TIME;\n}"
    end_function

    init_function "format_hour_stop" "hour"
        echo -e "var HOUR=hour.substr(hour.indexOf(\"-\")+1,4);\nvar Length=HOUR.length;\nif (Length == 3)\n{\nvar TIME=hour.substr(hour.indexOf(\"-\")+1,1)+\":\"+hour.substr(hour.indexOf(\"-\")+2,2);\nreturn TIME;\n}\nelse if (Length == 4)\n{\nvar TIME=hour.substr(hour.indexOf(\"-\")+1,2)+\":\"+hour.substr(hour.indexOf(\"-\")+3,2);\nreturn TIME;\n}\nelse\n{\nvar TIME=\"\"\nreturn TIME;\n}"
    end_function

    init_function "form_edit" "id,login,directory,password,uid,gid,gecos,upbandwidth,downbandwidth,upratio,downratio,maxconnection,filequota,sizequota,localipallow,localipdeny,clientipallow,clientipdeny,time"
        script_formshow "pureftpd-users" "edit"
        set_form_value "pureftpd-users" "action" "'edit'"
        set_form_value "pureftpd-users" "id" "id"
        set_form_value "pureftpd-users" "old_password" "password"
        set_form_value "pureftpd-users" "login" "login"
        set_form_value "pureftpd-users" "password" "password"
        set_form_value "pureftpd-users" "directory" "directory_return(directory)"
        set_form_value "pureftpd-users" "total_access" "chrooted_return(directory)"
        set_form_value "pureftpd-users" "upload" "bandwidth_return(upratio)"
        set_form_value "pureftpd-users" "download" "bandwidth_return(downratio)"
        set_form_value "pureftpd-users" "files" "filequota"
        set_form_value "pureftpd-users" "size" "size_return(sizequota)"
        set_form_value "pureftpd-users" "hour_start" "format_hour_start(time)"
        set_form_value "pureftpd-users" "hour_stop" "format_hour_stop(time)"
    end_function

    init_validation "validate_form"
         add_validation "login" "VALID_ISNOTNULL"
         add_validation "password" "VALID_ISNOTNULL"
         add_validation "directory" "VALID_ISNOTNULL"
         add_validation "upload" "VALID_NUMBERS"
         add_validation "download" "VALID_NUMBERS"
         add_validation "files" "VALID_NUMBERS"
         add_validation "size" "VALID_NUMBERS"
    end_validation
end_script

body " Pure-FTPd - $BFW0366" "/images/add_user.png"

init_form "pureftpd-users" "500px" "$BFW0366" "/pure-ftpd/pure-ftpd-user.cgi" "validate_form"
    init_infoitem
        input_hidden "id" ""
        input_hidden "action" ""
        input_hidden "old_password" ""
        infoitem_form "Login:" "$(input_textbox "login" "" "25" "160px")" "$PUREFTPD016"
        infoitem_form "$BFW0169:" "$(input_password "password" "" "25" "160px")" "$PUREFTPD017"
        infoitem_form "$PUREFTPD001:" "$(input_textbox "directory" "" "50" "160px")" "$PUREFTPD018"
        infoitem_form "$PUREFTPD019:" "$(init_combobox "total_access" "65px";combobox_add "-D" "$BFW0095";combobox_add "-d" "$BFW0096" Selected;end_combobox)" "$PUREFTPD020<br>$BFW0358: <b>$BFW0096</b>"
        infoitem_form "$PUREFTPD021:" "Upload $(input_textbox "upload" "" "5" "60px") KB/s&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;&nbsp;Download $(input_textbox "download" "" "5" "60px") KB/s" "$PUREFTPD022"
        infoitem_form "$PUREFTPD023:" "$(input_textbox "files" "" "5" "60px") $BFW0045(s) $PUREFTPD024 $(input_textbox "size" "" "5" "60px") $PUREFTPD025" "$PUREFTPD022"
        infoitem_form "$PUREFTPD026:" "$PUREFTPD027$(input_textbox "hour_start" "" "5" "60px")$PUREFTPD028$(input_textbox "hour_stop" "" "5" "60px")" "$PUREFTPD029<br><b>$PUREFTPD030:</b> <i>$PUREFTPD027 xx:xx$PUREFTPD028 xx:xx</i><br><b>$PUREFTPD031:</b> <i>$PUREFTPD027 09:00 $PUREFTPD028 18:30</i>"
    end_infoitem
end_form

init_listview_without_comment "Login,180px" "$PUREFTPD001,300px"
    OIFS=$IFS
    IFS=":"
    loadconfig $FILECONFIG | sed s/#//g | while read LOGIN PASSWORD UID GID GECOS DIRECTORY UPBANDWIDTH DOWNBANDWIDTH UPRATIO DOWNRATIO MAXCONNECTION FILEQUOTA SIZEQUOTA LOCALIPALLOW LOCALIPDENY CLIENTIPALLOW CLIENTIPDENY TIME; do
               eval "$(echo "$LOGIN" | awk -F" " '{print "ID="$1;print "LOGIN=\""substr($0,length($1)+2)"\""}')"
               listview_add_custom "$ID" "2" "$LOGIN" "$DIRECTORY" "$PASSWORD" "$UID" "$GID" "$GECOS" "$UPBANDWIDTH" "$DOWNBANDWIDTH" "$UPRATIO" "$DOWNRATIO" "$MAXCONNECTION" "$FILEQUOTA" "$SIZEQUOTA" "$LOCALIPALLOW" "$LOCALIPDENY" "$CLIENTIPALLOW" "$CLIENTIPDENY" "$TIME"
    done 
    IFS=$OIFS
end_listview 
end_body
end_html
